#pragma hdrstop
//#pragma link "PhysikEingabe"
//#pragma link "Dialogfenster"
#include "UserEditor.h"
#include "PhysikEingabe.h"
#include <dialogs.hpp> // nur fr debuggen
#pragma package(smart_init)

//---------------------------------------------------------------------------
//#pragma package(smart_init)

__fastcall KUserValues::KUserValues(AnsiString String)
{
  TPersistent();
  int pos;
  int leng;
  AnsiString buf;
  for(int i=0;i<10;i++)
  {
   buf=String;
   leng=String.Length();
   pos=buf.AnsiPos("***");
   buf=buf.Delete(pos,leng-(pos-1));
   EinheitenMatrix[i]=buf;
   String.Delete(1,pos+2);
   buf=String;
   leng=String.Length();
   pos=buf.AnsiPos("***");
   buf=buf.Delete(pos,leng-(pos-1));
   UmrechnungsMatrix[i]=StrToFloat(buf);
   String.Delete(1,pos+2);
  }
}

AnsiString __fastcall  KUserValues::ToString(void)
{
  AnsiString s="";
  for(int i=0;i<10;i++)
  {
   s+=EinheitenMatrix[i]+"***"+FloatToStr(UmrechnungsMatrix[i])+"***";
  }
  return s;
}



AnsiString UserEinheit[10];
double UserUmrechnung[10];

/*
void __fastcall KUserEditor::SetValue(AnsiString val)
{
  ShowMessage(val);
};
*/


void __fastcall KUserEditor::Edit(void)
{
  TDialogForm* Dialog = new TDialogForm(Application);
  KUserValues* uv = new KUserValues(((KString*)GetOrdValue())->s);
  Value=uv->ToString();
  for(int i=0;i<10;i++)
  {
   UserEinheit[i]=uv->EinheitenMatrix[i];
   UserUmrechnung[i]=uv->UmrechnungsMatrix[i];
  }

  Dialog->ShowModal();

  for(int i=0;i<10;i++)
  {
   uv->EinheitenMatrix[i]=UserEinheit[i];
   uv->UmrechnungsMatrix[i]=UserUmrechnung[i];
  }
  SetValue(uv->ToString());
  KPhysikEingabe* ph = (KPhysikEingabe*) GetComponent(0);
  KString *ks=new KString();
  ks->s=Value;
  ph->UserWerte=ks;

  /*
  KPhysikEingabe* ph;
  for(int index=0;index<PropCount;index++)
  {
    ph=(KPhysikEingabe*) GetComponent(index);
    ph->UserWerte->EinheitenMatrix[0]=uv->EinheitenMatrix[0];
    ph->UserWerte->UmrechnungsMatrix[0]=1; // SI-Einheit ist immer im ersten Feld
    for(int i=1;i<10;i++)
    {
     if(UserEinheit[i]!="SI-Einheit") //nur falls eine Einheit eingetragen wurde
     {
         ph->UserWerte->EinheitenMatrix[i]=uv->EinheitenMatrix[i];
         ph->UserWerte->UmrechnungsMatrix[i]=uv->UmrechnungsMatrix[i];
     }
    }
 //   SetValue("SetValue");
    ph->Einheiten=User_defined;

    //ph->EingestellteEinheit=UserEinheit[0];
  }
  */
 delete Dialog;
  //Value="Test";
  Modified();
}

/*
namespace UserEditor
{
  void __fastcall PACKAGE Register()
   {
    RegisterPropertyEditor( __typeinfo(KUserValues),0L,
                "",__classid(KUserEditor) );
   }
}
 */
